%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Script for making the DREAM Matlab mex-files for Unix  (Linux,
% Mac OS X, etc.) without fftw support for the attenuation code.
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% $Revision: 618 $ $Date: 2009-11-08 22:09:03 +0100 (Sun, 08 Nov 2009) $ $LastChangedBy: dream $

%
% Flags.
%

TOOLBOX = 1;
MISC = 1;
EXTRA = 1;
INSTALL = 1;

disp(' ');
disp('Note you need to remove the -ansi flag in your ~/.matlab/R200Xx/mexopts.sh file')
disp('if you have not already done so!')
pause(3);
disp(' ');


if TOOLBOX

  cd src
  
  %
  % Single transducer functions.
  %
  
  fprintf('Building the DREAM toolbox MEX-functions:\n\n');
  
  fprintf('Compiling dreamline...');
  mex  -I../include  ...
      mex_dreamline.c dreamline.c att.c fft.c dream_error.c -output dreamline
  fprintf('done!\n');
  
  fprintf('Compiling dreamrect...');
  mex -I../include  ...
      mex_dreamrect.c dreamrect.c att.c fft.c dream_error.c -output dreamrect
  fprintf('done!\n');
  
  fprintf('Compiling dreamrect_f...');
  mex -I../include  ...
      mex_dreamrect_f.c dreamrect_f.c att.c fft.c dream_error.c -output dreamrect_f
  fprintf('done!\n');
  
  fprintf('Compiling dreamcirc...');
  mex -I../include  ...
      mex_dreamcirc.c dreamcirc.c att.c fft.c dream_error.c -output dreamcirc
  fprintf('done!\n');
  
  fprintf('Compiling dreamcirc_f...');
  mex -I../include  ...
      mex_dreamcirc_f.c dreamcirc_f.c att.c fft.c dream_error.c  -output dreamcirc_f
  fprintf('done!\n');
  
  fprintf('Compiling dreamcylind_f...');
  mex -I../include  ...
      mex_dreamcylind_f.c dreamcylind_f.c att.c fft.c dream_error.c -output dreamcylind_f
  fprintf('done!\n');
  
  fprintf('Compiling dreamcylind_d...');
  mex -I../include  ...
      mex_dreamcylind_d.c dreamcylind_d.c att.c fft.c dream_error.c -output dreamcylind_d
  fprintf('done!\n');
  
  fprintf('Compiling dreamsphere_f...');
  mex -I../include  ...
      mex_dreamsphere_f.c dreamsphere_f.c att.c fft.c dream_error.c -output dreamsphere_f
  fprintf('done!\n');
  
  fprintf('Compiling dreamsphere_d...');
  mex -I../include  ...
      mex_dreamsphere_d.c dreamsphere_d.c att.c fft.c dream_error.c -output dreamsphere_d
  fprintf('done!\n');
  
  % Array functions.
  
  fprintf('Compiling dream_arr_circ...');
  mex -I../include  ...
      mex_dream_arr_circ.c dream_arr_circ.c ...
      arr_functions.c att.c fft.c  dream_error.c -output dream_arr_circ
  fprintf('done!\n');
  
  fprintf('Compiling dream_arr_rect...');
  mex -I../include  ...
      mex_dream_arr_rect.c dream_arr_rect.c ...
      arr_functions.c  att.c fft.c dream_error.c -output dream_arr_rect
  fprintf('done!\n');
  
  fprintf('Compiling dream_arr_cylind_f...');
  mex -I../include  ...
      mex_dream_arr_cylind_f.c dream_arr_cylind_f.c ...
      dream_error.c arr_functions.c att.c fft.c  -output dream_arr_cylind_f
  fprintf('done!\n');
  
  fprintf('Compiling dream_arr_cylind_d...');
  mex -I../include  ...
      mex_dream_arr_cylind_d.c dream_arr_cylind_d.c ...
      arr_functions.c att.c fft.c  dream_error.c  -output dream_arr_cylind_d
  fprintf('done!\n');
  
  fprintf('Compiling dream_arr_annu...');
  mex -I../include  ...
      mex_dream_arr_annu.c dream_arr_annu.c ...
      att.c fft.c  dream_error.c  -output dream_arr_annu
  
  cd ../
  fprintf('\nBuild of (serial) DREAM toolbox functions done!\n');
  
  fprintf('\nBuilding the parallel DREAM toolbox MEX-functions:\n\n');
  
  cd src
  
  fprintf('Compiling dreamline_p...');
  mex -I../include -lpthread ...
      mex_dreamline_p.c dreamline.c att.c fft.c dream_error.c -output dreamline_p
  fprintf('done!\n');
  
  fprintf('Compiling dreamrect_p...');
  mex -I../include -lpthread ...
      mex_dreamrect_p.c dreamrect.c att.c fft.c dream_error.c -output dreamrect_p
  fprintf('done!\n');
  
  fprintf('Compiling dreamrect_f_p...');
  mex -I../include -lpthread ...
      mex_dreamrect_f_p.c dreamrect_f.c att.c fft.c dream_error.c -output dreamrect_f_p
  fprintf('done!\n');
  
  fprintf('Compiling dreamcirc_p...');
  mex -I../include -lpthread ...
      mex_dreamcirc_p.c dreamcirc.c att.c fft.c dream_error.c -output dreamcirc_p
  fprintf('done!\n');
  
  fprintf('Compiling dreamcirc_f_p...');
  mex -I../include -lpthread ...
      mex_dreamcirc_f_p.c dreamcirc_f.c att.c fft.c dream_error.c  -output dreamcirc_f_p
  fprintf('done!\n');
  
  fprintf('Compiling dreamcylind_f_p...');
  mex -I../include -lpthread ...
      mex_dreamcylind_f_p.c dreamcylind_f.c att.c fft.c dream_error.c -output dreamcylind_f_p
  fprintf('done!\n');
  
  fprintf('Compiling dreamcylind_d_p...');
  mex -I../include -lpthread ...
      mex_dreamcylind_d_p.c dreamcylind_d.c att.c fft.c dream_error.c -output dreamcylind_d_p
  fprintf('done!\n');
  
  fprintf('Compiling dreamsphere_f_p...');
  mex -I../include -lpthread ...
      mex_dreamsphere_f_p.c dreamsphere_f.c att.c fft.c dream_error.c   -output dreamsphere_f_p
  fprintf('done!\n');
  
  fprintf('Compiling dreamsphere_d_p...');
  mex -I../include -lpthread ...
      mex_dreamsphere_d_p.c dreamsphere_d.c att.c fft.c dream_error.c   -output  dreamsphere_d_p
  fprintf('done!\n');
  
  % Array functions.
  
  fprintf('Compiling dream_arr_circ_p...');
  mex -I../include -lpthread ...
      mex_dream_arr_circ_p.c dream_arr_circ.c ...
      arr_functions.c att.c fft.c  dream_error.c -output dream_arr_circ_p
  fprintf('done!\n');
  
  fprintf('Compiling dream_arr_rect_p...');
  mex -I../include -lpthread ...
      mex_dream_arr_rect_p.c dream_arr_rect.c ...
      arr_functions.c  att.c fft.c dream_error.c -output dream_arr_rect_p
  fprintf('done!\n');
  
  fprintf('Compiling dream_arr_cylind_f_p...');
  mex -I../include -lpthread ...
      mex_dream_arr_cylind_f_p.c dream_arr_cylind_f.c ...
      dream_error.c arr_functions.c att.c fft.c  -output dream_arr_cylind_f_p
  fprintf('done!\n');
  
  fprintf('Compiling dream_arr_cylind_d_p...');
  mex -I../include -lpthread ...
      mex_dream_arr_cylind_d_p.c dream_arr_cylind_d.c ...
      arr_functions.c att.c fft.c  dream_error.c  -output dream_arr_cylind_d_p
  fprintf('done!\n');
  
  fprintf('Compiling dream_arr_annu_p...');
  mex -I../include -lpthread ...
      mex_dream_arr_annu_p.c dream_arr_annu.c ...
      att.c fft.c  dream_error.c  -output dream_arr_annu_p
  fprintf('done!\n');
  
  cd ../
  
  fprintf('Build of parallel DREAM toolbox functions done!\n');  
  
end

if MISC
  
  %
  % Misc functions.
  %
  
  fprintf('\nBuilding the Misc DREAM toolbox MEX-functions:\n\n');
  
  cd src
  
  fprintf('Compiling dream_apodwin...');
  mex -I../include  ...
      mex_dream_apodwin.c arr_functions.c ...
      dream_error.c -output dream_apodwin
  fprintf('done!\n');
  
  fprintf('Compiling dream_att...');
  mex -I../include  ...
      mex_dream_att.c att.c fft.c dream_error.c ...
      -output dream_att
  fprintf('done!\n');
  
  cd ../
  
  %
  cd extra_src
  
  fprintf('Compiling conv_p...');
  mex -I../include -lpthread ...
      mex_conv_p.c dream_error.c -output conv_p
  fprintf('done!\n');
  
  fprintf('Compiling fftconv_p...');
  mex -I../include -lpthread -lfftw3 ...
      mex_fftconv_p.c dream_error.c -output fftconv_p
  fprintf('done!\n');
  
  fprintf('Compiling sum_fftconv_p...');
  mex -I../include -lpthread -lfftw3 ...
      mex_sum_fftconv_p.c dream_error.c -output sum_fftconv_p
  fprintf('done!\n');
  
  fprintf('Compiling copy_p...');
  mex -I../include -lpthread ...
      mex_copy_p.c dream_error.c -output copy_p
  fprintf('done!\n');
  
  cd ../
  fprintf('Build of Misc DREAM toolbox functions done!\n');
end

if EXTRA

  cd extra_src
  
  fprintf('\nBuilding the Extra DREAM toolbox MEX-functions:\n\n');

  fprintf('Compiling das...');
  mex -I../include ...
      mex_das.c das.c dream_error.c -output das
  fprintf('done!\n');
  
  fprintf('Compiling das_arr...');
  mex -I../include ...
      mex_das_arr.c  das_arr.c arr_functions.c dream_error.c -output das_arr
  fprintf('done!\n');
  
  %
  % Analytic methods.
  %
  
  fprintf('Compiling circ_sir...');
  mex -I../include ...
      mex_circ_sir.c circ_sir.c dream_error.c -output circ_sir
  fprintf('done!\n');
  
  fprintf('Compiling scirc_sir...');
  mex -I../include ...
      mex_scirc_sir.c scirc_sir.c dream_error.c -output scirc_sir
  fprintf('done!\n');
  
  fprintf('Compiling rect_sir...');
  mex -I../include ...
      mex_rect_sir.c rect_sir.c dream_error.c -output rect_sir
  fprintf('done!\n');
  
  %
  % SAFT
  %
  
  fprintf('Compiling saft...');
  mex -I../include ...
      mex_saft.c dream_error.c -output saft
  fprintf('done!\n');
  
  fprintf('Compiling saft_p...');
  mex -I../include -lpthread ...
      mex_saft_p.c dream_error.c -output saft_p
  fprintf('done!\n');
  
  cd ../
  
  fprintf('Build of Extra DREAM toolbox functions done!\n');
end

if INSTALL

  %
  % Install into the arch dir.
  %
  
  [status,SYSTEM] = system('uname -s');
  [status,ARCH] = system('uname -m');
  [status,PWD] = system('pwd');
  
  if (size(strfind(SYSTEM,'Linux'),1) > 0)
    
    if  ( (size(strfind(ARCH,'i386'),1) > 0) || (size(strfind(ARCH,'i686'),1) > 0))
      cd src
      system('mkdir -p ../arch/x86/');
      system('mkdir -p ../arch/x86/linux');
      system('cp *.mex* ../arch/x86/linux/');
      cd ../
      cd extra_src
      system('cp *.mex* ../arch/x86/');
      fprintf('\nThe mex-files are installed in: %s/arch/x86/linux/\n',PWD)
      cd ../
    elseif (size(strfind(ARCH,'x86_64'),1) > 0)
      cd src
      system('mkdir -p ../arch/x86_64');
      system('mkdir -p ../arch/x86_64/linux');
      system('cp *.mexa* ../arch/x86_64/linux/');
      cd ../
      cd extra_src
      system('cp *.mexa* ../arch/x86_64/dream/');
      fprintf('\nThe mex-files are installed in: %s/arch/x86_64/\n',PWD)
      cd ../
    end
    
    % Mac OS X.
  elseif (size(strfind(SYSTEM,'Darwin'),1) > 0)
    cd src
    system('mkdir -p ../arch/x86_64');
    system('mkdir -p ../arch/x86_64/maci');
    system('cp *.mexmaci ../arch/x86_64/maci/');
    cd ../
    cd extra_src
    system('cp *.mexmaci ../arch/x86_64/maci/');
    fprintf('\nThe mex-files are installed in: %s/arch/x86_64/maci/\n',PWD)
    cd ../
  end

end
