/***
*
* Copyright (C) 2003,2004,2006,2008,2009 Fredrik Lingvall
*
* This file is part of the DREAM Toolbox.
*
* The DREAM Toolbox is free software; you can redistribute it and/or modify 
* it under the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2, or (at your option) any
* later version.
*
* The DREAM Toolbox is distributed in the hope that it will be useful, but 
* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License
* along with the DREAM Toolbox; see the file COPYING.  If not, write to the 
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
* 02110-1301, USA.
*
***/

// $Revision: 565 $ $Date: 2009-09-17 22:24:06 +0200 (Thu, 17 Sep 2009) $ $LastChangedBy: dream $

#include "dream_error.h"

#ifdef OCTAVE
#include <stdio.h>
#else
#include <mex.h>
#endif

/***
 *
 * Functions for error handling.
 *
 ***/

int dream_out_of_bounds_err(char *msg, int idx, int err_level)
{

  switch(err_level) {

  case STOP:

#ifdef OCTAVE
    printf(msg);
    printf(" (offset = %d samples)\n",idx);
#else
    mexPrintf(msg);
    mexPrintf(" (offset = %d samples)\n",idx);
    mexErrMsgTxt(""); // Bail out!
#endif
    break;
    
  case WARN:
#ifdef OCTAVE
    printf(msg);
    printf(" (offset = %d samples)\n",idx);
#else
    mexPrintf(msg);
    mexPrintf(" (offset = %d samples)\n",idx);
#endif
    break;

  case IGNORE:
    break; // Do nothing.

  case PARALLEL_STOP:
#ifdef OCTAVE
    printf(msg);
    printf(" (offset = %d samples)\n",idx);
#else
    mexPrintf(msg);
    mexPrintf(" (offset = %d samples)\n",idx);
#endif
    break; 

  default:
    break;
  }
    
  return err_level;
}

void dream_err_msg(char *msg)
{

#ifdef OCTAVE
  printf(msg);
  return;
#else
  mexErrMsgTxt(msg);
#endif

  return;
}
