#!/bin/bash

##########################################
#
# A script to patch and cross compile the
# pthreads-w32-2-8-0-release for Win64.
#
# Copyright (C) 2009 Fredrik Lingvall
#
##########################################

# $Revision: 600 $ $Date: 2009-11-08 16:32:40 +0100 (Sun, 08 Nov 2009) $ $LastChangedBy: dream $

rm -fr pthreads-w32-2-8-0-release
rm -fr pthreads-w64-2-8-0-release

tar xvzf pthreads-w32-2-8-0-release.tar.gz

cp -a pthreads-w32-2-8-0-release pthreads-w64-2-8-0-release

cd pthreads-w64-2-8-0-release

# Apply the 64 bit patch (which is the compined 
# patches below [which don't apply cleanly] plus 
# a fix in ptw32_InterlockedCompareExchange.c  
# to detect the MinGW-w64 compiler properly.

patch -p1 -f < ../pthreads-w64-dream.patch

# These patches don't patch cleanly:
#
# From: http://www.cadforte.com/wiki/index.php/Pthreads

#cd tests
#ln -s SIZES.GC sizes.gc
#cd ..

# Patch #1
#patch -p1 -f < ../pthreads-w64.patch

# Patch #2
#patch -p0 < ../pthread.sched-h.patch

# Patch #3
#patch -p 0 < ../pthread.h.config.patch

#
# Build the lib with the MinGW-w64 tool chain
#
make CROSS=x86_64-w64-mingw32- clean GC-inlined

#
# Copy the lib to dll_64 folder.
#
cp pthreadGC2.dll ../dll_64 
cp pthread.def ../dll_64 

# Copy the header files.
cp pthread.h ../dll_64 
cp sched.h ../dll_64 
cp semaphore.h ../dll_64 

# Note: you must create the lib files to 
# use this lib with MSCV (see the files:
#
#  README_MAKE_64_BIT_LIB_FILES.txt
#  make_pthread_lib_file_64.bat
#
# in the dll_64 folder.

# The used diff command for the patch:
# diff -Nbaurpad pthreads-w32-2-8-0-release pthreads-w64-2-8-0-release > pthreads-w64-dream.patch
