#!/bin/bash

#
# Download the fftw and Pthreads windows libs.
#


#
# Pthreads-win32 
#

#MinGW
wget ftp://sourceware.org/pub/pthreads-win32/dll-latest/lib/pthreadGC2.dll

# Make the def file.
echo EXPORTS > pthreadGC2.def
nm pthreadGC2.dll | grep ' T _' | sed 's/.* T _//' >> pthreadGC2.def


#MSVC
wget ftp://sourceware.org/pub/pthreads-win32/dll-latest/lib/pthreadVC2.dll
wget ftp://sourceware.org/pub/pthreads-win32/dll-latest/lib/pthreadVC2.lib

wget ftp://sourceware.org/pub/pthreads-win32/dll-latest/include/pthread.h
wget ftp://sourceware.org/pub/pthreads-win32/dll-latest/include/sched.h
wget ftp://sourceware.org/pub/pthreads-win32/dll-latest/include/semaphore.h

#
# FFTW
#

mkdir -p fftw
cd fftw
wget ftp://ftp.fftw.org/pub/fftw/fftw-3.1.2-dll.zip
unzip fftw-3.1.2-dll.zip
cd ..
cp fftw/libfftw3-3.dll libfftw3.dll
cp fftw/libfftw3-3.def libfftw3.def

echo ""
echo "Run this on the Windows machine using the MinGW dlltool:"
echo ""
echo "  dlltool -d file.def -D pthreadGC2.dll  -l  -v pthreadGC2.dll"
echo ""
echo "Run this on the Windows machine the MSVC lib tool:"
echo ""
echo "  lib /machine:i386 /def:libfftw3-3.def"
echo "  lib /machine:i386 /def:libfftw3f-3.def"
echo "  lib /machine:i386 /def:libfftw3l-3.def"
echo "" 
echo "You may need to copy the def-files to MATLAB/extern/include/ !"
